// this mixin is for use in variables.styl, to create a programmatic colour system.
// $color is a required argument, but the others can be defined optionally.
// if you wanted to add 10% to the saturation of $color, you would call the mixin as so:
// modify-hsla($color: $cl--first, $s: 10)
// if you wanted to subtract .2 from the alpha of $color, you would call the mixin as so:
// modify-hsla($color: $cl--first, $a: -.2)
modify-hsla($color, $h="", $s="", $l="", $a="")
    // convert the colour value to a string so that we can operate on it
    $color  = join(" ", $color)
    // slice away everything other than the list of values
    $color  = slice($color, 5, -1)
    // remove units from the list of values so that we can operate on it
    $color  = replace("%", "", $color)
    // split the colour into an array
    $values = split(",", $color)
    // split the array into numbers which we can operate on
    $hue        = convert($values[0])
    $saturation = convert($values[1])
    $lightness  = convert($values[2])
    $alpha      = convert($values[3])
    // if present, add/subtract the arguments to their relevant part in the HSLA
    if $h is a 'unit'
        $hue = $hue + $h
    if $s is a 'unit'
        $saturation = $saturation + $s
    if $l is a 'unit'
        $lightness = $lightness + $l
    if $a is a 'unit'
        $alpha = $alpha + $a
    // compile the final values into a CSS HSLA value
    $final-value = "hsla(" + $hue + "," + $saturation + "%," + $lightness + "%," + $alpha + ")"
    // remove string quotes from the final value so that it is valid CSS
    return unquote($final-value)

// here are some examples of this in use:
// $cl--first        = hsla(199, 44%, 19%, 1)
// $cl--first--low   = modify-hsla($color: $cl--first, $s: -6, $l: -6)
// $cl--first--med   = modify-hsla($color: $cl--first, $s: 11, $l: 11)
// $cl--first--high  = modify-hsla($color: $cl--first, $s: 22, $l: 22)


// mixin for transitions; adds a will-change value for each property chosen
trans($time = 0.14s, $easing = ease-out, $properties = "background-color, box-shadow")
    will-change unquote($properties)
    transition-property unquote($properties)
    transition-duration $time
    transition-timing-function $easing

// mixin to add margin-top to an item if another child precedes it
// must be used on a single selector; will not work on nested selectors
mt($margin-top = $sp)
    * + &
        margin-top $margin-top

// mixin to add margin-left to an item if another child precedes it
// must be used on a single selector; will not work on nested selectors
ml($margin-left = $sp)
    * + &
        margin-left $margin-left

// mixin for centered container element
contain($display = flex)
    display $display
    width 92%
    max-width $container
    margin-right auto
    margin-left auto

// mixin for resetting button elements
button-reset()
    cursor pointer
    border none
    background-color transparent
    padding 0
    font inherit
    color inherit

// mixin to avoid by default giving an element an unintended
// z-index context when giving an element position: relative
pos-r()
    position relative
    z-index auto

// mixin to avoid by default giving an element an unintended
// z-index context when giving an element position: absolute
pos-a()
    position absolute
    z-index auto

content-anchor(
    $initial-color     = $cl--anchor,
    $interaction-color = $cl--anchor--interact
)
    trans($properties: "box-shadow, color")
    box-shadow inset 0 0 0 modify-hsla($color: hsla($interaction-color), $a: -.6)
    color $initial-color

    &:active
    &:focus
    &:hover
        box-shadow inset 0 -2px 0 modify-hsla($color: hsla($interaction-color), $a: -.6)
        color $interaction-color
